/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.philulay.buchcom.controller;

import de.philulay.buchcom.model.Category;
import de.philulay.buchcom.model.Medium;
import de.philulay.buchcom.system.BC_Controller;
import de.philulay.buchcom.system.BC_Login;
import java.util.ArrayList;
import java.util.List;
import javax.el.ELContext;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

/**
 *
 * @author kew
 */
@ManagedBean
@SessionScoped 
public class CategoryC extends BC_Controller {

    
    private Category category = new Category();
    private List<Medium> media = new ArrayList<Medium>();
    private List<Category> cats = new ArrayList<Category>();
   
    public void updateCategory(){
        em = emf.createEntityManager();
        media = em.createNamedQuery(Medium.BY_USERNAME, Medium.class).setParameter("username", this.getUsername()).getResultList();
        cats = em.createNamedQuery(Category.BY_USERNAME, Category.class).setParameter("username", this.getUsername()).getResultList();
        em.close();
    }
    
    @Override
    public void reset() {
        this.category = new Category();
        this.media = new ArrayList<Medium>();
        this.cats = new ArrayList<Category>();
        
        ELContext elContext = FacesContext.getCurrentInstance().getELContext();
        BC_Login l = (BC_Login) FacesContext.getCurrentInstance().getApplication().getELResolver().getValue(elContext, null, "bC_Login");
        this.setUsername(l.getName());
    }
    
    public String add(){
        //System.out.println(category);
        FacesContext ctxt = FacesContext.getCurrentInstance();
        FacesMessage ms = new FacesMessage("Erfolgreich eingetragen");
        try {
            this.category.setUsername(this.getUsername());
            
            em = emf.createEntityManager(); 
            utx.begin();
            em.persist(category);
            media= em.createNamedQuery(Medium.ALL, Medium.class).getResultList();
            utx.commit();
        } catch (Exception e) {
            try {
                ms = new FacesMessage(e.getMessage());
                utx.rollback();
            } catch (Exception e2) {
                ms = new FacesMessage(e2.getMessage());
            }
        } finally {
            if (em != null) {
                em.close();
            }
        }
        ctxt.addMessage(null, ms);
        category = new Category();
        return INDEX;
    }

    public Category getCategory() {
        return category;
    }

    public void setCategory(Category category) {
        this.category = category;
    }

    public List<Category> getCats() {
        return cats;
    }

    public void setCats(List<Category> cats) {
        this.cats = cats;
    }

    public List<Medium> getMedia() {
        return media;
    }

    public void setMedia(List<Medium> media) {
        this.media = media;
    }
    
    
    
    
    
}
