/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.philulay.buchcom.controller;

import de.philulay.buchcom.model.Category;
import de.philulay.buchcom.model.Medium;
import de.philulay.buchcom.system.BC_Controller;
import de.philulay.buchcom.system.BC_Login;
import de.philulay.buchcom.system.BC_RequestHelper;
import java.util.ArrayList;
import java.util.List;
import javax.el.ELContext;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

/** 
 *
 * @author Philipp
 */
@ManagedBean
@SessionScoped 
public class MediumC extends BC_Controller {

    

    private Medium lastmedium = new Medium();
    private Medium medium = new Medium();
    private List<Medium> media = new ArrayList<Medium>();
    private List<Category> cats = new ArrayList<Category>();

    public void updateMedia(){
        em = emf.createEntityManager();
        media = em.createNamedQuery(Medium.BY_USERNAME, Medium.class).setParameter("username", this.getUsername()).getResultList();
        cats = em.createNamedQuery(Category.BY_USERNAME, Category.class).setParameter("username", this.getUsername()).getResultList();
        em.close();
    }

    
    @Override
    public void reset(){
        this.medium = new Medium();
        this.media = new ArrayList<Medium>();
        this.cats = new ArrayList<Category>();
        this.lastmedium = new Medium();
        ELContext elContext = FacesContext.getCurrentInstance().getELContext();
        BC_Login l = (BC_Login) FacesContext.getCurrentInstance().getApplication().getELResolver().getValue(elContext, null, "bC_Login");
        this.setUsername(l.getName());
        
    }
    
    public void getMediumById(){
        
        String id = BC_RequestHelper.getRequestParameter("id");
        em = emf.createEntityManager();
        medium = em.find(Medium.class, Long.parseLong(id));
        em.close();
    }
    
    public void getLastMedium(){
        
        // einzeln
        /*
        em = emf.createEntityManager();
        List<Medium> a = new ArrayList<Medium>();
        a = em.createQuery("SELECT m FROM Medium m ORDER BY m.id DESC").setMaxResults(1).getResultList();
        em.close();
        if(a.isEmpty()){ 
            lastmedium = new Medium();
        } else {
            lastmedium = a.get(0);
        }*/
        
        
        // ganze tabelle
        
        em = emf.createEntityManager();
        List<Medium> a = new ArrayList<Medium>();
        a = em.createQuery("SELECT m FROM Medium m ORDER BY m.id DESC").getResultList();
        em.close();
        if(a.isEmpty()){ 
            lastmedium = new Medium();
        } else {
            lastmedium = a.get(0);
        }
        
            
        
    }
    
    public String add(){
        //System.out.println(medium);
        //System.out.println("Medium add()"+medium);
        FacesContext ctxt = FacesContext.getCurrentInstance();
        FacesMessage ms = new FacesMessage("Erfolgreich eingetragen");
        try {
            this.medium.setUsername(this.getUsername());
            em = emf.createEntityManager(); 
            utx.begin();
            em.persist(medium);
            media= em.createNamedQuery(Medium.ALL, Medium.class).getResultList();
            utx.commit();
        } catch (Exception e) {
            try {
                ms = new FacesMessage(e.getMessage());
                utx.rollback();
            } catch (Exception e2) {
                ms = new FacesMessage(e2.getMessage());
            }
        } finally {
            if (em != null) {
                em.close();
            }
        }
        ctxt.addMessage(null, ms);
        medium = new Medium();
        return INDEX;
    }
    
    public Category getCategoryById(Long id){
        em = emf.createEntityManager();
        Category r = em.find(Category.class, id);
        em.close();
        System.out.println("getCategoryById: "+r);
        return r;
    }

    public List<Medium> getMedia() {
        return media;
    }

    public void setMedia(List<Medium> media) {
        this.media = media;
    }

    public Medium getMedium() {
        return medium;
    }

    public void setMedium(Medium medium) {
        this.medium = medium;
    }

    public List<Category> getCats() {
        return cats;
    }

    public void setCats(List<Category> cats) {
        this.cats = cats;
    }

    public Medium getLastmedium() {
        return lastmedium;
    }

    public void setLastmedium(Medium lastmedium) {
        this.lastmedium = lastmedium;
    }




    
    
        
        
}