/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.philulay.buchcom.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;

/**
 *
 * @author Philipp
 */
@Entity
@NamedQueries({
@NamedQuery(name = Category.ALL, query = "SELECT c FROM Category c"),
@NamedQuery(name = Category.BY_ID, query="SELECT c FROM Category c WHERE c.id=:id"),
@NamedQuery(name = Category.BY_USERNAME, query="SELECT c FROM Category c WHERE c.username=:username")
})
public class Category implements Serializable {
    

    public static final String ALL="alle kategorien";
    public static final String BY_ID="kategorie nach id";
    public static final String BY_USERNAME="kategorie nach username";
    
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    
    private String username;
    private String name;
    
    @OneToMany(mappedBy="category")
    private Set<Medium> media;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }



    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String toString() {
        return this.name;
    }





    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public Set<Medium> getMedia() {
        return media;
    }

    public void setMedia(Set<Medium> media) {
        this.media = media;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Category other = (Category) obj;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) {
            return false;
        }
        if ((this.username == null) ? (other.username != null) : !this.username.equals(other.username)) {
            return false;
        }
        if ((this.name == null) ? (other.name != null) : !this.name.equals(other.name)) {
            return false;
        }
        if (this.media != other.media && (this.media == null || !this.media.equals(other.media))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 37 * hash + (this.id != null ? this.id.hashCode() : 0);
        hash = 37 * hash + (this.username != null ? this.username.hashCode() : 0);
        hash = 37 * hash + (this.name != null ? this.name.hashCode() : 0);
        hash = 37 * hash + (this.media != null ? this.media.hashCode() : 0);
        return hash;
    }

    
    
    
}
